package ho.tests.thread.synchro.test1.order1.launch;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
/**
 * Thread launching example
 * @author Huseyin OZVEREN
 */
public class ApplicationLaunch {
	public static void main(String[] args) {
		
		System.out.println( "Starting threads in main thread" );
		
		// create and name each runnable
		MyTask th1 = new MyTask("threadname_1");
		MyTask th2 = new MyTask("threadname_2");
		MyTask th3 = new MyTask("threadname_3");

		// create ExecutorService to manage threads OR empty (better)
		ExecutorService es = Executors.newFixedThreadPool(3);
		
		// start threads and place in runnable state 
		es.execute(th1);
		es.execute(th2);
		es.execute(th3);

		// shutdown worker threads  
		es.shutdown();
		
		System.out.println( "Threads started, main thread ends\n" );
	}
}